<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 07/10/2004 *
 * ===============                              Last change: 07/10/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : register_functions.php                           *
 * -------------------------------------------------------------------- *
 * Short description : Special functions for register extension         *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Spezielle Funktion fuer register-Erweiterung     *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

//
function REGISTER_FILL_MUST_CONSTANTS()
{
	$result = SQL_QUERY("SELECT field_name, field_required FROM `{!_MYSQL_PREFIX!}_must_register` ORDER BY `id`", __FUNCTION__, __LINE__);
	while (list($name, $required) = SQL_FETCHROW($result)) {
		$value = "";
		if ($required == "Y") $value = "<div class=\\\"guest_failed\\\">&nbsp;(*)</div>";
		$eval = "define('MUST_".strtoupper($name)."', \"".$value."\");";
		eval($eval);
	} // END - while

	// Free memory
	SQL_FREERESULT($result);

	// Also fill other constants
	define('MUST_GENDER', "<div class=\"guest_failed\">&nbsp;(*)</div>");
	define('MUST_ADDY'  , "<div class=\"guest_failed\">&nbsp;(*)</div>");
	define('MUST_BIRTH' , "<div class=\"guest_failed\">&nbsp;(*)</div>");
	define('MUST_MARKER', "<div class=\"guest_failed\">&nbsp;(*)</div>");
}
//
function REGISTER_CHECK_REQUIRED_FIELDS(&$array)
{
	$ret = false;
	foreach ($array as $key => $value)
	{
		$result = SQL_QUERY("SELECT field_required FROM `{!_MYSQL_PREFIX!}_must_register` WHERE field_name='".$key."' LIMIT 1", __FUNCTION__, __LINE__);
		if (SQL_NUMROWS($result) == 1)
		{
			// "Must-line" found
			list($chk) = SQL_FETCHROW($result);
			SQL_FREERESULT($result);

			// Check if extension country is not found (you have to enter the 2-chars long country code) or
			// if extensions is present check if country code was selected
			//         01              2         21    12             3         32    234     5      54    4               43    34                      4    4      5      5432    2      3                      3210
			$country = ((!EXT_IS_ACTIVE("country")) || ((EXT_IS_ACTIVE("country")) && (((empty($value)) && ($key == "cntry")) || (($key == "country_code") && (!empty($value)))) && (!empty($array['country_code']))));
			if ((empty($value)) && ($chk == "Y") && (!$country))
			{
				// Required field not set
				$array[$key] = "!";
				$ret = true;
			}
		}
	}
	return $ret;
}
//
function REGISTER_OUTPUT_REQUIRE_CHECK(&$array)
{
	$result = SQL_QUERY("SELECT field_name, field_required FROM `{!_MYSQL_PREFIX!}_must_register` ORDER BY `id`", __FUNCTION__, __LINE__);
	while (list($name, $required) = SQL_FETCHROW($result))
	{
		if (($array[$name] == "!") && ($required == "Y")) {
			// Empty entry found
			$array[$name] = "";
			$OUT = constant('REGISTER_'.strtoupper($name).'_REQUIRED');
			OUTPUT_HTML("<div class=\"register_failed\">".$OUT."</div>");
		}
	}

	// Free memory
	SQL_FREERESULT($result);
}
//
function REGISTER_ADD_CATEGORY_TABLE ($MODE, $return=false) {
	$OUT = "";

	// Guests are mostly not interested in how many members has
	// choosen an individual category
	$AND = "WHERE `visible`='Y' ";

	// Admins are allowed to see every category...
	if (IS_ADMIN()) $AND = "";
	$result = SQL_QUERY("SELECT id, cat, visible FROM `{!_MYSQL_PREFIX!}_cats` ".$AND." ORDER BY `sort`", __FUNCTION__, __LINE__);
	if (SQL_NUMROWS($result) > 0) {
		// List alle visible modules (or all to the admin)
		$SW = 2;
		$OUT .= "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">\n";
		while (list($id, $cat, $visible) = SQL_FETCHROW($result)) {
			// Is the array element not set?
			if (!REQUEST_ISSET_POST('cat', $id)) {
				// Then set it
				REQUEST_SET_POST(array('cat', $id), "");
			} // END - if

			// Prepare array for the template
			$content = array(
				'sw'    => $SW,
				'cat'   => $cat,
				'def_y' => "",
				'def_n' => "",
				'id'    => $id,
			);

			if ((REQUEST_POST('cat', $id) == "Y") || ((getConfig('register_default') == "Y") && (!REQUEST_ISSET_POST('cat', $id)))) {
				$content['def_y'] = " checked=\"checked\"";
			} else {
				$content['def_n'] = " checked=\"checked\"";
			}

			// Load template and switch color
			$OUT .= LOAD_TEMPLATE("guest_cat_row", true, $content);
			$SW = 3 - $SW;
		}
		$OUT .= "</table>\n";

		// Free memory
		SQL_FREERESULT($result);
	} else {
		// No categories setted up so far...
		$OUT .= LOAD_TEMPLATE("admin_settings_saved", true, getMessage('NO_CATEGORIES_VISIBLE'));
	}

	if ($return) {
		// Return generated HTML code
		return $OUT;
	} else {
		// Output directly (default)
		OUTPUT_HTML($OUT);
	}
}
//
?>
